(  open.MUF     by Gyroplast 09/27/98                         )
(                                                             )
(  Creates and links an exit.                                 )
(                                                             )
: usage
  "USAGE:" .tell
  " " .tell
  " @open <dir>[=<room#>] " .tell
  " " .tell
  " <dir> specifies the name of the exit " .tell
  " [=<room#>] specifies the room the exit should be linked to and may be omitted." .tell
  " " .tell
  "So, if you want to create an exit 'out;ou;o' to room #1234 you type: " .tell
  "  @open out;ou;o=#1234" .tell
;
: main
  dup not if usage exit then
  strip
  dup "=" instring not if
  me @ location
  dup owner me @ dbcmp not if "You do not own the room you're in!" .tell exit then
  swap
  dup "#" instring if "That's a strange name for an action! Think about it!" .tell exit then
  newexit intostr
  "Exit with number " swap strcat
  " created. NO LINK." strcat .tell
  exit then
  "=" explode
  2 = not if usage exit then
  
  swap
  "" "#" subst atoi dbref
  dup #0 dbcmp if 
    "Sorry, but you can't link the exit to Room Zero!" .tell exit 
  then
  dup ok? not if 
    "FAILED! Destination is not a valid DBref!" .tell exit 
  then
  dup owner me @ dbcmp 
  me @ "W" flag? OR
  over "L" flag? OR not if
    "You do not own the target room, or it is not set LINK_OK. Aborting."
    .tell exit
  then 
  swap
  
  me @ location
  swap
  newexit
  dup intostr
  "Exit with number " swap strcat
  " created, attempting to link... " strcat .tell
  swap
  dup "L" flag? not if "Destination not LINK_OK, switching flags..." .tell
   dup "L" set
   swap over
   setlink
   dup
   "!L" set
  else
  swap over
  setlink
  then
  "SUCCESS. Exit linked to " swap name strcat "." strcat .tell
;

