( [Current as of Jan. 1, 1998 on Frontiers MUCK]                            )
( Person-to-Person Combat V3.5 by Steve Conley [Fleet Admiral Oliver Otter] )
( ------------------------------------------------------------------------- )
( [c] 1997 Project INSANITY Software.  Highly portable software--no wizard  )
( bit required for main functions.  wcreate/acreate/mkcreate might have     )
( problems, though [with newobject]                                         )
( ------------------------------------------------------------------------- )
$def .xansplit .split
$def server #228 ( What object should we store props on? )
$def univ   #228 ( What is the dbref of the companion University program )
                 ( by Larissa@S:TFF?  If you DON'T have the University   )
                 ( program, just point this to an object with a prop     )
                 ( _skills on it, which is a space-seperated list of     )
                 ( weapon skills [ie _skills:unarmed blaster sword]      )
$def VER "3.5"
$def WPREFIX "@" ( This is put before all the standard props on weapons  )
                 ( and armour.  If this is a wizbitted program, it's     )
                 ( probably best to have an '@' here.  Otherwise, '_'    )
                 ( will have to do, but then people can make their own   )
                 ( weapons without paying for them >:P                   )
var enemyname
var weapon
: getdex ( s -- i ) ( Grabs dex for name )
  server swap
  "_" swap strcat "/dex" strcat getpropstr
  atoi
;
: getexp ( s -- i ) ( Grabs exp for name )
  server swap
  "_" swap strcat "/exp" strcat getpropstr
  atoi
;
: gethp ( s -- i ) ( Grabs hp for name )
  server swap "_" swap strcat "/hp" strcat getpropstr atoi
;
: getstr ( s -- i ) ( Grabs str for name )
  server swap "_" swap strcat "/str" strcat getpropstr atoi
;
: setdex ( s i -- ) ( Sets dex to 'i' )
  server ( s i d )
  rot rot swap ( d i s )
  "_" swap strcat "/dex" strcat swap intostr setprop
;
: setexp ( s i -- ) ( Sets exp to 'i' )
  server rot rot swap "_" swap strcat "/exp" strcat swap intostr setprop
;
: sethp ( s i -- ) ( Sets hp to 'i' )
  server rot rot swap "_" swap strcat "/hp" strcat swap intostr setprop
;
: setstr ( s i -- ) ( Sets str to 'i' )
  server rot rot swap "_" swap strcat "/str" strcat swap intostr setprop
;
: hit? ( -- b )
  random
  me @ name getexp
  me @ name getdex %
  me @ name getdex + 1 + %
  random
  enemyname @ getdex %
  >
;
lvar str
: parse_str ( s -- s' ) ( Takes a string and gives you back the string )
                        ( with replacements done.                      )
  str !
  begin
    str @ "%v" instring str @ "%k" instring or while
    str @ "%v" instring dup if
      str @ swap strcut
      ( "str%" "vstr" )
      1 strcut swap pop 2 strcut swap enemyname @ match swap pronoun_sub swap
      strcat swap dup strlen 1 - strcut pop swap strcat
      str !
    then
    str @ "%k" instring dup if
      str @ swap strcut
      ( "str%" "kstr" )
      1 strcut swap pop 2 strcut swap me @ swap pronoun_sub swap
      strcat swap dup strlen 1 - strcut pop swap strcat
      str !
    then
  repeat
  str @
;
lvar x
lvar y
lvar z
: doDamage ( -- ) ( Does damage to enemy )
  weapon @ WPREFIX "type" strcat getpropstr tolower "ranged" strcmp not if
    weapon @ WPREFIX "dam" strcat getpropstr tolower
    dup "d" instring not if
      pop ">>> Error: Weapon damage string must be in '<number>d<number format." 
      .tell exit
    then
    "d" .xansplit ( mod dice )
    dup "+" instring if
      "+" .xansplit atoi z !
      else
        0 z !
    then
    atoi y !
    atoi x !
    0
    begin ( Simulate dice roll )
      x @ while
      random y @ % 1 + +
      x @ 1 - x !
    repeat
    z @ +
    else
      weapon @ WPREFIX "dam" strcat getpropstr tolower
      dup "d" instring not if
        pop ">>> Error: Weapon damage string must be in '<number>d<number format." 
        .tell exit
      then
      "d" .xansplit ( mod dice random )
      atoi y !
      atoi x !
      0
      begin ( Simulate dice roll )
        x @ while
        random y @ % 1 + +
        x @ 1 - x !
      repeat
      me @ name getstr +
      enemyname @ getdex -
  then
  ( dam )
  server enemyname @ "_" swap strcat
  "/armour" strcat
  getpropstr ( dam armour )
  atoi dbref
  dup ok? if
    dup location enemyname @ match dbcmp if
      dup WPREFIX "alevel" strcat getpropstr ( dam d alevel )
      atoi
      ( dam d alevel )
      dup ( dam d alevel alevel )
      4 rotate ( d alevel alevel dam )
      swap -
      dup 0 < if
        pop 0
      then
      ( d alevel realdam )
      3 rotate ( alevel realdam d )
      3 rotate ( realdam d alevel )
      1 -
      WPREFIX "alevel" strcat swap intostr setprop
      else pop
    then
    else pop
  then
  enemyname @ gethp swap -
  enemyname @ swap sethp
  enemyname @ gethp 0 > if
    me @ name getexp
    random 10 % + me @ name swap setexp
    exit
  then
  me @ location 0
  enemyname @ " falls to the ground from %v%p wounds!" strcat
  parse_str swap pop
  notify_exclude
  me @ name getexp
  random 50 % +
  me @ name swap setexp
;
: doattack ( s -- ) ( Attack 's' )
  dup strlen not if ( Null target string? )
    pop ">>> Please provide a target -- See " command @ strcat " #help for help." strcat .tell
    exit
  then
  match ( Match the object )
  dup me @ dbcmp if
    pop ">>> Why would you want to hit yourself?" .tell exit
  then
  dup player? not if ( Not a player? )
    dup thing? not if ( Not an object? )
      pop "You can only attack players or objects." .tell exit
    then
    dup owner me @ dbcmp if ( Foolcheck--don't kill your own object. )
      pop "You can't attack objects you own." .tell exit
    then
  then
  ( d -- Database number of confirmed target )
  dup location me @ location dbcmp not if ( Keep dumbasses from farkilling )
    pop "You can only attack things that are in the same room!" .tell exit
  then
  dup owner awake? not if ( Is the target/target's owner awake? )
    pop "That person is not awake!" .tell exit
  then
  server "_" me @ name strcat "/weapon" strcat getpropstr
  dup strlen not trigger @ WPREFIX "weapon?" strcat getpropstr tolower "yes" strcmp and if
( Is the person using a weapon and/or a weapon action? )
    pop pop ">>> You need to arm a weapon first, or use a weapon action" .tell
    exit
  then
  command @ "fire" strcmp if ( If we're not using the fire command )
    pop trigger @ weapon !
    else atoi dbref
         dup location me @ dbcmp not if ( Foolproof--no farweilding )
           pop pop ">>> You are not holding the weapon you have armed!" .tell exit
         then
         dup WPREFIX "weapon?" strcat getpropstr tolower "yes" strcmp if
( Make sure it's a weapon )
           pop pop ">>> You need to arm a weapon!" .tell exit
         then
         weapon !
  then
  name enemyname ! ( Store the enemy's name.  We no longer need the dbref. )
  server "_" enemyname @ strcat propdir? not if
( Is the target in the combat system? )
    ">>> That person is not using this combat program." .tell exit
  then
  server "_" me @ name strcat "/skills/" strcat
  weapon @ WPREFIX "skill" strcat getpropstr strcat
  getpropstr
  tolower "yes" strcmp if ( Do I know the skill needed to use this weapon? )
    ">>> You can't figure out how to attack with that!" .tell exit
  then
  weapon @ WPREFIX "clip" strcat getpropstr dup strlen if ( Using a clip? )
    ( s )
    server ( s d )
    swap ( d s ) 
    "_" me @ name strcat "/" strcat ( d s s )
    swap strcat ( d s )
    getpropstr atoi dup 1 < if
      pop ">>> Not enough ammo for that weapon!" .tell exit
    then
    ( i )
    1 - intostr server swap "_" me @ name strcat "/" strcat
    weapon @ WPREFIX "clip" strcat getpropstr strcat swap setprop
    ( Decrement clip value )
  then
  hit? if ( Did we hit? )
    weapon @ "_succ" getpropstr parse_str .tell
    weapon @ "_osucc" getpropstr me @ name " " strcat swap strcat
    parse_str .otell ( Display succ/osucc messages )
    doDamage ( Deal damage )
    else
      weapon @ "_fail" getpropstr parse_str .tell
      me @ name " " strcat weapon @ "_ofail" getpropstr strcat parse_str .otell
  then
  weapon @ WPREFIX "reload_time" strcat getpropstr dup strlen if
    atoi
    "%k%n pauses to reload %k%p weapon." parse_str .otell
    "You pause to reload your weapon." .tell
    pop pop
    sleep
    "%k%n finishes reloading." parse_str .otell
    "You finish reloading your weapon." .tell
    else pop
  then
;
: status
  "[HP:"
  me @ name gethp intostr strcat
  "(Out of:" strcat
  server "_" me @ name strcat "/maxhp" strcat getpropstr strcat
  ")|EXP:" strcat
  me @ name getexp intostr strcat
  "|DEX:" strcat
  me @ name getdex intostr strcat
  "|STR:" strcat
  me @ name getstr intostr strcat
  "]" strcat
  .tell
  "[Starship Combat Experience:"
  server "_" me @ name strcat "/stexp" strcat getpropstr strcat "]" strcat
  .tell
  "Weilding: "
  server "_" me @ name strcat "/weapon" strcat getpropstr
  dup strlen not if
    pop pop
    else atoi dbref name strcat .tell
  then
  "Wearing: "
  server "_" me @ name strcat "/armour" strcat getpropstr
  dup strlen not if
    pop pop
  else 
    atoi dbref dup name swap 
    WPREFIX "alevel" strcat getpropstr
    "   [ Armor Level: " swap strcat " ]" strcat
    strcat strcat .tell
  then
  "Your skills are:" .tell
  server "_" me @ name strcat "/skills/" strcat nextprop
  begin
    dup strlen while
    dup "/" .xansplit swap pop "/" .xansplit swap pop .tell
    server swap nextprop
  repeat
  pop
;
( Heal -- Setup -- Create weapon -- Create Armour -- Helpfile )
( Arm -- Wear -- Remove )
: heal ( s -- ) ( Attempts to heal 's' )
  match
  dup player? not if
    dup thing? not if
      pop "You can only heal players or things." .tell exit
  then then
  dup me @ dbcmp if
    pop "You can't heal yourself." .tell exit
  then
  dup location me @ location dbcmp not if
    pop "Ok, Einstein, how do you expect to heal people not in the same room as you?" .tell
    exit
  then
  me @ name gethp not if
    pop "Stupid, you can't heal people if you're dead." .tell exit
  then
(  dup name server swap "_" swap strcat "/ver" strcat getpropstr
  VER strcmp if
    pop "That person is either not using the combat program, or is using the wrong version." .tell
    exit
  then
) server "_" me @ name strcat "/skills/doctor" strcat getpropstr
  tolower "yes" strcmp if
    pop "You're not a doctor!" .tell exit
  then
  "Healed!" .tell
  dup name me @ location swap me @ swap 1 swap
  me @ name " heals " strcat swap strcat "!" strcat notify_exclude
  dup name server swap "_" swap strcat "/hp" strcat getpropstr atoi
  random 20 % 1 + +
  ( d i )
  swap dup name server swap "_" swap strcat "/maxhp" strcat getpropstr atoi
  ( hp d max )
  3 rotate ( d max hp )
  dup ( d max hp hp )
  3 rotate ( d hp hp max ) dup ( d hp hp max max )
  3 rotate ( d hp max max hp ) swap
  > if
    swap pop
  else pop
  then
  ( d hp )
  swap name server swap "_" swap strcat "/hp" strcat ( hp d p )
  3 rotate intostr setprop
;
( setup -- create weapon -- create armour -- helpfile -- arm -- wear )
( remove )
: setup
  server "_" me @ name strcat propdir? if
    ">>> You're already set up." .tell exit
  then
  random 20 % 10 +
  me @ name swap setdex
  random 20 % 10 + me @ name swap setstr
  me @ name 100 sethp
  server "_" me @ name strcat "/maxhp" strcat "100" setprop
  me @ name 100 setexp
  server "_" me @ name strcat "/skills/general" strcat "yes" setprop
  "Status now at:" .tell
  status
  "Done setting up." .tell
;
( create weapon -- create armour -- helpfile -- arm -- wear -- remove )
lvar wobj
lvar dam
lvar type
lvar skill
lvar reload
lvar clip
: wcreate ( -- )
  ">>> This will step through the process of making a weapon.  Please note" .tell
  ">>> that while you can make a weapon by hand, it's not suggested as you" .tell
  ">>> may not keep all the standarizations intact.  If your weapon does not " .tell
  ">>> follow certain guidelines, you will have it removed by the wizzes." .tell
  " " .tell
  ">>> What do you want to call this weapon?" .tell
  read wobj !
  ">>> Type in the damage dice in the form <multipler>d<size of dice>" .tell
  ">>> This will roll a dice the size indicated and multiply it by   " .tell
  ">>> the multiplier indicated.  IE: 2d5 would roll a dice of size  " .tell
  ">>> 5, producing a number between 0 and 5, then multiply it by 2. " .tell
  ">>> These two values can be anything you want, but PLEASE keep it " .tell
  ">>> at a logical level (no phasers with 100d50000 or anything like" .tell
  ">>> that).  Any weapons too powerful may be removed by the wizards" .tell
  ">>> The cost of the weapon is determined by how much damage it does." .tell
  read
  dup "d" instring not
  over "d" .xansplit swap pop atoi 1 < or if
    pop ">>> The weapon damage value has to be in the form '<number>d<number>'" .tell
        ">>> Like: 2d5.  Aborting." .tell
        exit
  then
  dup
  dam !
  "d" .xansplit
  ( X Y )
  atoi swap atoi dup * * 50 *
  dup 1 < if
    "No, I don't think that is acceptable. Aborting." .tell
    exit
  then
  dup me @ pennies > if
    pop "You can't afford a weapon that powerful." .tell exit
  then
  dup "That will cost " swap intostr strcat " credits.  Do you want to continue? (y/N)" strcat
  .tell
  read
  tolower "y" strcmp if
    pop "Aborted." .tell exit
  then
  0 swap - me @ swap addpennies
  ">>> If this is a ranged weapon--ie one that you shoot and strength" .tell
  ">>> has little or nothing to do with the damage--type ranged here." .tell
  ">>> Otherwise, type anything you want.  Things like phasers, bows " .tell
  ">>> and arrows, and slings would be considered 'ranged'.          " .tell
  read type !
  ">>> What skill is required to operate this weapon?  Please choose " .tell
  ">>> from the list below and type it in:                           " .tell
  univ "_skills" getpropstr .stripspaces ", " " " subst .tell
  read skill !
  ">>> How many seconds does it take to reload this weapon?  If you  " .tell
  ">>> put a '.' here, reloading is skipped--this is for weapons like" .tell
  ">>> machine guns or phasers that don't require reloading after    " .tell
  ">>> each time the weapon is fired.                                " .tell
  read 
  dup "." strcmp not if pop "" then reload !
  ">>> What is the clip of this weapon called?  Use '.' if this weapon" .tell
  ">>> does not require a clip, or is rechargable (ie phaser).  Use the" .tell
  ">>> mkclip program to make a clip for your weapon." .tell
  read dup "." strcmp not if pop "" then clip !
  ">>> Ok, the basics of your weapon are set.  You need to set the succ," .tell
  ">>> osucc, fail, and ofail messages; succ is what you see if you hit " .tell
  ">>> someone with the weapon, osucc is what everyone else sees with   " .tell
  ">>> your name prepended to it.  fail and ofail are the same, except  " .tell
  ">>> these are shown when you miss with that weapon.  To set them, use" .tell
  "@set weaponname=_succ:whatever" .tell
  "@set weaponname=_osucc:whatever" .tell
  "@set weaponname=_fail:whatever" .tell
  "@set weaponname=_ofail:whatever" .tell
  "You can use substitutions (see 'help %a') in these strings to put in" .tell
  "the attacker's/target's name/sex/etc in the message.  Just put '%k' " .tell
  "before a substitution that's supposed to use the attacker's settings" .tell
  "and a '%v' before a subsition for the target.  Example:  Tanabi, a  " .tell
  "male, fighting Natasha, a female, with the fail message:" .tell
  "You miss the living shit out of %v%n, making %v%o laugh %v%r to death."
  .tell
  "would show to Tanabi if he missed:" .tell
  "You miss the living shit out of Natasha, making her laugh herself to death."
  .tell
  me @ wobj @ newobject
  dup WPREFIX "dam" strcat dam @ setprop
  dup WPREFIX "type" strcat type @ setprop
  dup WPREFIX "skill" strcat skill @ setprop
  dup WPREFIX "clip" strcat clip @ setprop
  dup WPREFIX "weapon?" strcat "yes" setprop
  dup WPREFIX "reload_time" strcat reload @ setprop
  ">>> Done." .tell
;
( create armour -- helpfile -- arm -- wear -- remove )
: acreate
  ">>> What is the name of your armour?" .tell
  read
  ">>> How much damage can this armour absorb?  This will directly affect the" .tell
  ">>> price of the armour.  10-20 is suggested." .tell
  read
  ( s s )
  dup atoi
  dup * 20 *
  dup 1 < if
    "No, I don't think that is acceptable. Aborting." .tell
    exit
  then
  ( s s i )
  dup me @ pennies > if
    pop pop pop "You can't afford armour that powerful." .tell exit
  then
  dup ">>> This armour will cost " swap intostr strcat " credits.  Continue? (y/N)" strcat .tell
  read
  tolower "y" strcmp if
    pop "Aborted." .tell exit
  then
  0 swap -
  me @ swap addpennies
  ( name dam )
  swap me @ swap newobject
  dup WPREFIX "armour?" strcat "yes" setprop
  swap WPREFIX "alevel" strcat swap setprop
  ">>> Done." .tell
;
: mkclip
  ">>> Making a clip object.  What do you want to call this clip?" .tell
  ">>> Note that this name must be the name of the clip your weapon" .tell
  ">>> uses." .tell
  read
  ">>> How many rounds does this clip contain?  The price of the clip is" .tell
  ">>> 10 times the number of rounds." .tell
  read dup
  dup atoi 1 < if
    "No, I don't think negative values are acceptable. Aborting." .tell exit
  then
  atoi 10 *
  dup me @ pennies > if
    pop pop pop ">>> You can't afford that many rounds!" .tell exit
  then
  0 swap - me @ swap addpennies
  ( name rounds )
  swap me @ swap newobject
  dup WPREFIX "clip?" strcat "yes" setprop
  swap WPREFIX "rounds" strcat swap setprop
  ">>> Done." .tell
;
: installclip ( s -- )
  .stripspaces dup strlen not if
    pop ">>> What clip am I to load?" .tell exit
  then
  match
  dup thing? not if
    pop ">>> That's not an object." .tell exit
  then
  dup WPREFIX "clip?" strcat getpropstr tolower "yes" strcmp if
    pop ">>> That's not a clip." .tell exit
  then
  dup location me @ dbcmp not if
    pop ">>> But you're not holding that object!" .tell exit
  then
  server "_" me @ name strcat "/weapon" strcat getpropstr
  atoi dbref
  dup WPREFIX "weapon?" strcat getpropstr tolower "yes" strcmp if
    pop pop ">>> You don't have a weapon armed." .tell exit
  then
  dup location me @ dbcmp not if
    pop pop ">>> You're not holding that weapon." .tell exit
  then
  ( clipdb weapdb )
  swap dup ( weap clip clip )
  3 rotate ( clip clip weap )
  dup ( c c w w )
  3 rotate ( c w w c )
  name ( c w w cn )
  swap WPREFIX "clip" strcat getpropstr strcmp if
    pop pop ">>> That's the wrong type of clip for that weapon." .tell exit
  then
  pop
  ( c )
  server swap ( serv clip )
  dup "_" me @ name strcat "/" strcat swap name strcat dup
  ( serv clip propdir propdir  )
  4 rotate 
  ( clip propdir propdir serv )
  swap getpropstr atoi ( clip propdir val )
  3 rotate dup ( propdir val clip clip )
  3 rotate ( propdir clip clip val )
  swap WPREFIX "rounds" strcat getpropstr atoi +
  ( propdir clip totalrounds )
  swap recycle ( propdir totalrounds )
  server -3 rotate intostr setprop
  "You put the clip into your weapon." .tell
  "%n puts a clip into %p weapon."  me @ swap pronoun_sub .otell
;
: help
  "Combat V3.5 by Steve Conley (Fleet Admiral Tanabi)" .tell
  "--------------------------------------------------" .tell
  "This is a simple, self-maintaining combat program." .tell
  "==================================================" .tell
  "Commands:                                         " .tell
  "fire <target>  -- Fires an armed weapon at target " .tell
  "arm  <weapon>  -- Arms that weapon                " .tell
  "unarm          -- Unarms your weapon              " .tell
  "wear <armour>  -- Wears that armour               " .tell
  "remove         -- Removes your armour             " .tell
  "status         -- Displays your status            " .tell
  "wcreate        -- Create a weapon                 " .tell
  "acreate        -- Create armour                   " .tell
  "mkclip         -- Make a clip.                    " .tell
  "reload <clip>  -- Puts that clip in your weapon.  " .tell
  "heal <name>    -- Heals that person.              " .tell
  "combat         -- Sets you up for combat.         " .tell
  "==================================================" .tell
  "Notes: In order to heal people, you must be set as" .tell
  "a doctor.  " prog owner name strcat " can set you doctor." strcat .tell
  "--------------------------------------------------" .tell
  "An action, set up like a weapon and @linked to the" .tell
  "combat program, can be used to hand-to-hand combat" .tell
  "and things like that, which aren't 'arm'ed and    " .tell
  "'fire'd.  Create a weapon and use the same props  " .tell
  "on the exit as on the weapon; exits are not armed." .tell
  "Make sure the _type for all actions is NOT ranged." .tell
  "--------------------------------------------------" .tell
  "Its the job of the owner of the program to add in " .tell
  "commands to add skills and/or change dex/str.  exp" .tell
  "is gained through combat.                         " .tell
  "--------------------------------------------------" .tell
  "Lastly, armour wears down with use; each time you " .tell
  "are hit, your armour's effectiveness goes down by " .tell
  "one.  If your armour is too damage, it can start  " .tell
  "causing harm to you (negative effectiveness).     " .tell
  "Note this would happen IRL; armour bends, and gets" .tell
  "stiffer, etc, making it hard to dodge in.         " .tell
  "--------------------------------------------------" .tell
  "If you do not want any combat actions to be used  " .tell
  "in one of your rooms, simply set a _nocombat prop " .tell
  "on it, ie. '@set here=_nocombat:true'             " .tell
;
( arm -- wear -- remove )
: armwear ( s -- )
  dup .stripspaces strlen not if
    pop help exit
  then
  command @ tolower "arm" strcmp not if
    match dup thing? not if
      pop ">>> You can only arm things!" .tell exit
    then
    dup location me @ dbcmp not if
      pop ">>> You must be holding the thing to arm it!" .tell exit
    then
    dup WPREFIX "weapon?" strcat getpropstr tolower "yes" strcmp if
      pop ">>> That is not a weapon!" .tell exit
    then
    dup
    server swap
    "_" me @ name strcat "/weapon" strcat
    swap intostr setprop
    "Armed." .tell
    me @ name " arms the " strcat
    swap name strcat "." strcat .otell
    exit
  then
  match dup thing? not if
    pop ">>> You can only wear things!" .tell exit
  then
  dup location me @ dbcmp not if
    pop ">>> You must be holding the thing to wear it!" .tell exit
  then
  dup WPREFIX "armour?" strcat getpropstr tolower "yes" strcmp if
      pop ">>> That is not armour!" .tell exit
  then
  dup
  server swap
  "_" me @ name strcat "/armour" strcat
  swap intostr setprop
  "Worn." .tell
  me @ name " wears the " strcat
  swap name strcat "." strcat .otell
;
: remove
  command @ tolower "unarm" strcmp not if
    server "_" me @ name strcat "/weapon" strcat remove_prop
    "Unarmed." .tell
    "%k%n unarms %k%p weapon." parse_str .otell exit
  then
  server "_" me @ name strcat "/armour" strcat remove_prop
  "Removed." .tell
  "%k%n removes %k%p armour." parse_str .otell
;
: main ( Parse arguements and commands )
  tolower .stripspaces
  dup "#help" strcmp not if ( #help ? )
    pop help exit
  then
  me @ location "_nocombat" getpropstr if
   "Sorry, no combat actions are allowed in this room!" .tell exit
  then
  command @ tolower command !
  command @ "mkclip" strcmp not if
    pop mkclip exit
  then
  command @ "reload" strcmp not if
    installclip exit
  then
  command @ "fire" strcmp not if ( 'fire' command? )
    doattack exit
  then
  command @ "wcreate" strcmp not if
    pop wcreate exit
  then
  command @ "acreate" strcmp not if
    pop acreate exit
  then
  command @ "arm" strcmp not command @ "wear" strcmp not or if
    armwear exit
  then
  command @ "unarm" strcmp not command @ "remove" strcmp not or if
    remove exit
  then
  command @ "heal" strcmp not if
    heal exit
  then
  command @ "status" strcmp not if
    pop status exit
  then
  command @ "combat" strcmp not if
    pop setup exit
  then
  doattack
;

