(
  sensorama.muf     by Gyroplast  03/29/2000  v1.1
  set and show the taste, feel, scent, etc. of a character
 
  Follow the generic setup instructions below to globally
  install [recommended] the program.
 
   Step 1: Upload this program, and set it M3
   Step 2: Create an action attached to #0.
           The name of the action directly affects the available
           commands! Recommended is 'taste;smell;feel', but
           you can add as many names as you like. Do NOT use aliases
           for one and the same function like 'taste;tast;tas;ta', since it
           will NOT work as expected!
   Step 3: Link the action to this program.
 
  That's it. Run '#help' to see available commands.
)
$def header "sensorama.muf   by Gyroplast@FuzzyLogic  v1.10"
$def tprop "_" command @ strcat
 
: defaultmessage (  -- s )
  "++++ %n just " command @ strcat
  command @ dup strlen 1 - strcut swap pop
  dup "e" stringcmp not if pop "d" else
   dup "y" stringcmp not if pop "ied" else
    pop "ed"
   then
  then
  strcat " you!" strcat
;
 
: help
  header .tell
  "----------------------------------------------" .tell
  " " .tell
  " Commands:" .tell
  "   #set <message>    :  set the '" command @ strcat
  "' message to <message>" strcat .tell
  " Message is cleared if <message> is omitted." .tell
  " " .tell
  "   #notify <message> :  set message you see when '" command @ strcat
  "' is used on you." strcat .tell
  " If <message> is omitted, a generic default is used." .tell
  " " .tell
  " MPI and pronoun substitutions are evaluated in both messages." .tell
  " " .tell
;
 
: tasteset ( s --  )
  me @ tprop 3 pick 0 addprop
  if "Set." .tell else "Cleared." .tell then
;
 
: tastenotifyset ( s --  )
  me @ tprop "_notify" strcat 3 pick 0 addprop
  if 
   "Notification set." .tell 
  else
   "Notification set to default." .tell
  then
;
 
: tastenotify ( d d --  )
  over tprop "_notify" strcat "{@desc}" 1 parseprop
  dup not if pop defaultmessage then
  pronoun_sub notify
;
 
: taste ( d --  )
  dup me @ tastenotify
  dup tprop "{@desc}" 1 parseprop
  dup not if pop "You " command @ " nothing unusual." strcat strcat then
  pronoun_sub
;
 
: tasteall ( d --  )
  contents
  BEGIN
    dup #-1 dbcmp not while
    dup tprop getpropstr if
     dup name "[" swap strcat "]: " strcat over taste strcat .tell
    then
    next
  REPEAT
  pop
  "Done." .tell
;
 
: main
  strip
  dup not if 
    me @ location tasteall exit 
  then
  
  dup "#h" stringpfx if 
    pop help exit 
  then
 
  dup "#set" stringpfx if 
    " " .split swap pop tasteset exit 
  then
 
  dup "#notify" stringpfx if 
    " " .split swap pop tastenotifyset exit
  then
  match
  dup ok? not if 
    pop "I don't see that here, or it's ambiguous." .tell exit
  else
    taste .tell
  then
;

