(  
  GuestieTRaM.muf     by Gyroplast  12/04/98           v1.01             
 
  Assigns a morph to a connecting Guest, using an enhancable
  morph database. Works best in combination with GMEdit.muf.
  Do not use this TRaM on your player! Changes are permanent!
  
  SETUP:
  ------
    1. @create an object to be used as the morph database.
       Uses the program itself by default. NOT RECOMMENDED!
    2. Set the $def below to the db# of the db-object.
    3. Put this prog into the _connect property of all guests.
       ex: @set <guest>=_connect/tram:<progdb#>
    4. Add some morphs.
 
  I won't include detailed information here on how to set up morphs
  manually. Either check the sourcecode for the properties, use 
  GMEdit.muf {recommended}, or ask Gyroplast if you're really stuck.
 
  CHANGES:
    v1.01 - Added a mixed mode. Run the program with parameter
            'mixed', and it'll randomly take every prop out of
            different morphs. Looks like a tentacle, smells like
            a skunk, barks like a fox.. etc.
    v1.00 - First release
 
  Oh, almost forgot, have phun! <g>
 
  *** check http://www.gyroplast.com for this and many other programs! ***
  *** This program is distributed under the GPL. Porting and mods      ***
  *** are explicitly allowed as long as this header stays intact, and  ***
  *** the result of any modification is distributed under the GPL.     ***
  *** For a detailed description of the DOs and DONTs, read the GPL at ***
  *** http://www.gyroplast.com/help/gpl.txt   --Thank you--            ***
 
) 
(*** Change this to the dbref# of the created morph database object! ***)
$def database #4099
 
LVAR count
 
: getrndmorph
  BEGIN
   database "_morphcount" getpropstr atoi
   dup if
    random swap % 1 +
   else
    pop 0 break
   then
   database over "@morph/" swap intostr strcat "/deny" strcat
   getpropstr not
   over database swap "@morph/" swap intostr strcat "/reviewed" strcat
   getpropstr and
  UNTIL
;
: mvdesc      ( i --  ) (morph# --  )
  dup not if
   pop
   me @ "redesc#" "1" 0 ADDPROP
   me @ "redesc#/1" "You see nothing special." 0 ADDPROP
  else
   intostr
   0 count !
   BEGIN
    count @ 1 + count !
    dup database swap "@morph/" swap strcat "/desc#" strcat getpropstr
    atoi dup count @ < if
     intostr me @ swap "redesc#" swap 0 ADDPROP pop break
    else
     pop
    then
    database over "@morph/" swap strcat "/desc#/" count @ intostr strcat strcat
    getpropstr
    me @ swap "redesc#/" count @ intostr strcat swap 0 ADDPROP
   REPEAT
   me @ "{eval:{list:redesc}}" setdesc
  then
;
: mvscent     ( i --  ) (morph# --  )
  dup not if
   pop
   me @ "_scent" "You smell nothing special." 0 ADDPROP
  else
   intostr
   me @ swap database swap
   "@morph/" swap strcat "/scent" strcat
   getpropstr
   "_scent" swap 0 ADDPROP
  then
;
: mvspecies     ( i --  ) (morph# --  )
  dup not if
   pop
   me @ "species" "guestie" 0 ADDPROP
  else
   intostr
   me @ swap database swap
   "@morph/" swap strcat "/species" strcat
   getpropstr
   "species" swap 0 ADDPROP
  then
;
: mvgender     ( i --  ) (morph# --  )
  dup not if
   pop
   me @ "gender" "fluff" 0 ADDPROP
   me @ "sex" "fluff" 0 ADDPROP
  else
   intostr
   me @ swap database swap
   "@morph/" swap strcat "/sex" strcat
   getpropstr over over
   "gender" swap 0 ADDPROP
   "sex" swap 0 ADDPROP
  then
;
: mvsay     ( i --  ) (morph# --  )
  dup not if
   pop
   me @
   "_say/def/say"
   "say" 0 ADDPROP
   me @
   "_say/def/osay"
   "says" 0 ADDPROP
  else
   intostr
   dup
   database swap
   "@morph/" swap strcat "/say" strcat
   getpropstr me @ swap
   "_say/def/say"
   swap 0 ADDPROP
   database swap
   "@morph/" swap strcat "/osay" strcat
   getpropstr me @ swap
   "_say/def/osay"
   swap 0 ADDPROP
  then
;
: mixmorph    (  --  )
  getrndmorph mvdesc
  getrndmorph mvscent
  getrndmorph mvgender
  getrndmorph mvspecies
  getrndmorph mvsay
  "You morph into an odd mix of characters!"
  .tell
;
: domorph    (  --  )
  dup mvdesc
  dup mvscent
  dup mvgender
  dup mvspecies
  dup mvsay
  dup not if
   pop "No morphs available. Default values set." .tell
  else
   intostr
   "Character #" over strcat " has been assigned to you! " strcat swap
   "Created by: " database "@morph/" 4 rotate strcat "/creator" strcat
   getpropstr strcat strcat
   .tell
  then
;
: main
  STRIP
  dup "mixed" stringcmp not if pop mixmorph exit then
  pop getrndmorph domorph
;

